/* CC_NAME - The class name your custom control is registered under */
#define CC_NAME             DndEdit

/* CC_CLASS_NAME - Same as CC_NAME value, but in quotes */
#define CC_CLASS_NAME       "DndEdit"

/* CC_DEFAULT_STYLE - Default style bits for your custom control */
#define CC_DEFAULT_STYLE    WS_CHILD|WS_VISIBLE\
                          | WS_BORDER|ES_MULTILINE|ES_LEFT\
                          | WS_TABSTOP|WS_VSCROLL|WS_HSCROLL\
                          | ES_AUTOVSCROLL|ES_AUTOHSCROLL

typedef struct CC_FLAG
    {
    long    Flag;
    char    *Symbol;
    }   CC_FLAG;

#if  defined(TACKY_TRICK)
/* CcFlags - Names and values of all control style bits */
static  CC_FLAG CcFlags[] =
    {
    { ES_CENTER,        "ES_CENTER"         },
    { ES_RIGHT,         "ES_RIGHT"          },
    { ES_MULTILINE,     "ES_MULTILINE"      },
    { ES_UPPERCASE,     "ES_UPPERCASE"      },
    { ES_LOWERCASE,     "ES_LOWERCASE"      },
    { ES_PASSWORD,      "ES_PASSWORD"       },
    { ES_AUTOVSCROLL,   "ES_AUTOVSCROLL"    },
    { ES_AUTOHSCROLL,   "ES_AUTOHSCROLL"    },
    { ES_NOHIDESEL,     "ES_NOHIDESEL"      },
    { ES_OEMCONVERT,    "ES_OEMCONVERT"     },
#if (WINVER >= 0x0301)
    { ES_READONLY,      "ES_READONLY"       },
    { ES_WANTRETURN,    "ES_WANTRETURN"     }
#endif
    };

#endif

/* CC_TITLE - Arbitrary text, not used for much by any tool I know of */
#define CC_TITLE        "DndEdit - Drag-and-Drop Edit control. " \
                        " Copyright 1992 Windows/DOS Developer's Journal"

/* CC_DEFAULT_WIDTH  - Default width in dialog units or (if high
 *                     bit set) in pixels.                       */
#define CC_DEFAULT_WIDTH    50

/* CC_DEFAULT_HEIGHT - Default width in dialog units or (if high
 *                     bit set) in pixels.                       */
#define CC_DEFAULT_HEIGHT   50

/* CC_VERSION - upper byte is major version, lower is minor      */
#define CC_VERSION      0x0100

/*  You do not have to redefine these unless you want different names for
 *  these functions
 */

/* best not to think about ANSI token pasting rules ... */
#define CONCAT_(a,b)  CONCAT__(a,b)
#define CONCAT__(a,b)  a##b

#define CC_REGISTER_FUNC    CONCAT_(CC_NAME, Register)
#define CC_UNREGISTER_FUNC  CONCAT_(CC_NAME, Unregister)
#define CC_DIALOG_FUNC      CONCAT_(CC_NAME, Dialog)
#define CC_INFO_FUNC        CONCAT_(CC_NAME, Info)
#define CC_FLAGS_FUNC       CONCAT_(CC_NAME, Flags)
#define CC_STYLE_FUNC       CONCAT_(CC_NAME, Style)

#define CC_DIALOG_NAME      CC_CLASS_NAME "_Dialog"
#define CC_BITMAP_NAME      CC_CLASS_NAME "_Bitmap"
#define CC_CURSOR_NAME      CC_CLASS_NAME "_Cursor"

/*  None of the following should change */

typedef struct  CC_INIT_DIALOG
    {
    BOOL        Extended;       /* TRUE if extended interface */
    HGLOBAL     StyleData;
    LPFNSTRTOID StrToId;
    LPFNIDTOSTR IdToStr;
    }           CC_INIT_DIALOG;
